 
/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __GTK_SORI_BUTTON_H__
#define __GTK_SORI_BUTTON_H__


#include <gtk/gtkbutton.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
	SoriButtonTypePixmap, SoriButtonTypeLabel
};

#define GTK_SORI_BUTTON(obj)          GTK_CHECK_CAST (obj, gtk_sori_button_get_type (), GtkSoriButton)
#define GTK_SORI_BUTTON_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_sori_button_get_type (), GtkSoriButtonClass)
#define GTK_IS_SORI_BUTTON(obj)       GTK_CHECK_TYPE (obj, gtk_sori_button_get_type ())


typedef struct _GtkSoriButton       GtkSoriButton;
typedef struct _GtkSoriButtonClass  GtkSoriButtonClass;

struct _GtkSoriButton
{
  GtkButton button;
  gint type;
  GdkPixmap *pixmap1;
  GdkPixmap *pixmap2;
  GdkBitmap *mask1, *mask2;
  GdkGC *gc; // for label mode
  GdkFont *font; // for label mode
  char *str;
  int width, height;
};

struct _GtkSoriButtonClass
{
	GtkButtonClass parent_class;
	void (*right_clicked)(GtkSoriButton *button);

};


guint      gtk_sori_button_get_type       (void);
GtkWidget* gtk_sori_button_new            (void);
GtkWidget* gtk_sori_button_new_with_label (gchar     *label, GdkGC *gc, GdkFont *font, int width, int height);
GtkWidget * gtk_sori_button_new_with_pixmap(GdkPixmap *pixmap1, 
                               GdkBitmap *mask1,
				               GdkPixmap *pixmap2, GdkBitmap *mask2, int width, int height);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_BUTTON_H__ */
