#ifndef __SORI_CONFIG_H__
#define __SORI_CONFIG_H__

#include <gtk/gtk.h>

#ifndef DATA_DIR
#define DATA_DIR "/usr/lib/sori"
#endif
enum {
	BitmapCenter,
	GradientColor
};

typedef struct _GlobalInfo GlobalInfo;
typedef struct _GlobalLabelInfo GlobalLabelInfo;
typedef struct _LabelInfo LabelInfo;
typedef struct _GlobalGaugeInfo GlobalGaugeInfo;
typedef struct _GaugeInfo GaugeInfo;
typedef struct _GlobalButtonInfo GlobalButtonInfo;
typedef struct _ButtonInfo ButtonInfo;
typedef struct _SoriConfig SoriConfig;



struct _GlobalInfo {
	int width, height;
	//char *pixmap_name;
	char *designer;
	GdkPixmap *pixmap;
	int background_mode;
	GdkColor *gradient_color_from;
	GdkColor *gradient_color_to;
	gboolean hide_window_border;
	gboolean use_window_shape;
	int number_of_shape_points;
	GdkPoint *shape_points;
};

struct _GlobalLabelInfo {
	char *font_name;
};

struct _LabelInfo {
	GdkColor *font_color;
	GdkFont *font;
	char *font_name;
	int font_size;
	int left, top;
	int width, height;
	gboolean font_bold, font_italic;
	gboolean show_bevel;
};

struct _GlobalGaugeInfo {
	gboolean show_shadow;
	int shadow_rel_pos_x, shadow_rel_pos_y;
	GdkColor *shadow_color;
	char *shadow_color_name;
};

struct _GaugeInfo {
	int left, top, width, height;
};

struct _GlobalButtonInfo {

	GdkColor *font_color;
	GdkFont *font;
	char *font_name;
	int font_size;
	gboolean font_bold, font_italic;
	gboolean show_bevel;
};


struct _ButtonInfo {
	//char *bitmap1_name;
	//char *bitmap2_name;
	GdkPixmap *pixmap1, *pixmap2;
	GdkBitmap *mask1, *mask2;
	char *caption;
	int left;
	int top;
	int height;
	int width;
};

struct _SoriConfig {
	GlobalInfo global;
	GlobalLabelInfo label;
	LabelInfo  song_name_label;
	LabelInfo  sori_logo_label; 

	GlobalGaugeInfo gauge;
	GaugeInfo song_pos_gauge;
	GaugeInfo play_list_pos_gauge;

	GlobalButtonInfo button;

	ButtonInfo play_button;
	ButtonInfo stop_button;
	ButtonInfo pause_button;
	ButtonInfo disk_operations_button;
	ButtonInfo song_information_button;
	ButtonInfo options_button;
	ButtonInfo about_button;
	ButtonInfo help_button;
	ButtonInfo rewind_button;
	ButtonInfo fast_forward_button;
	ButtonInfo previous_song_button;
	ButtonInfo next_song_button;
	ButtonInfo close_button;
	ButtonInfo minimize_button;
};

#endif /* _SORI_CONFIG_H__ */
