
/* this file is a part of sori software, (C) Hwang chi-duck 1997               */

#include <gtk/gtk.h>
#include <fnmatch.h>

#include "sori.h"
#include "dialog.h"
#include "gauge.h"
extern char *basename(char *);


extern char *read_line(FILE *fp);
void file_list_callback(GtkWidget * , GdkEventButton * , gpointer );
void delete_file_item(GtkWidget *w, int item);
void remove_all_cb(void);
void list_save_cb(GtkWidget *w);
void list_load_cb(GtkWidget *w);
void list_save(void);
void list_file_load(char *list_name);
void popup_delete_cb(GtkWidget *w, gpointer data);
void popup_play_cb(GtkWidget *w, gpointer data);
void album_list_append(char *file_name);

int current_file = -1;
int current_list_item;
int nfiles = 0;
GSList *filenames = NULL;
GtkWidget *file_list;
char *list_file_name = NULL;
GtkWidget *file_list_frame;
GtkMenuFactory *factory;
GtkWidget *list_name_entry;
GtkWidget *album_list;
GList  *album_name_list = NULL;

GtkWidget *album_list_create(void);


GtkWidget * 
create_file_list(GtkWidget * box)
{
	GtkWidget *scrolled_window;
	GtkWidget *vbox, *hbox, *button;
	GtkWidget *hseparator;
	GtkWidget *album_menu;
	GtkMenuEntry menuentry[] = {
		{"Delete", NULL, popup_delete_cb, NULL, NULL},
		{"Play", NULL, popup_play_cb, NULL, NULL}
	};
	int nmenu = sizeof(menuentry)/sizeof(menuentry[0]);
	factory = gtk_menu_factory_new(GTK_MENU_FACTORY_MENU);
	gtk_menu_factory_add_entries(factory, menuentry, nmenu);

	file_list_frame = box;

	vbox = gtk_vbox_new(FALSE, 2);
	gtk_container_add(GTK_CONTAINER(box), vbox);
	gtk_widget_show(vbox);

	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_set_usize(scrolled_window, 200, -1);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
							 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(vbox), scrolled_window);
	gtk_widget_show(scrolled_window);
	gtk_container_border_width((GtkContainer*)scrolled_window, 5);

	file_list = gtk_list_new();
	gtk_list_set_selection_mode(GTK_LIST(file_list), GTK_SELECTION_BROWSE);
	gtk_container_add(GTK_CONTAINER(scrolled_window), file_list);
	gtk_signal_connect(GTK_OBJECT(file_list), "button_press_event",
					   (GtkSignalFunc) file_list_callback, NULL);
					   /*
	gtk_signal_connect(GTK_OBJECT(file_list), "button_release_event",
					   (GtkSignalFunc) file_list_callback, NULL);
					   */
	gtk_widget_show(file_list);

    hbox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_end(GTK_BOX(vbox), hbox, FALSE, FALSE, 2);
	gtk_widget_show(hbox);

	button = gtk_button_new_with_label("Save to");
	gtk_container_add(GTK_CONTAINER(hbox), button);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(list_save_cb), NULL);
	gtk_widget_show(button);

	list_name_entry = gtk_entry_new();
	//gtk_signal_connect(GTK_OBJECT(button), "clicked",
	//	GTK_SIGNAL_FUNC(list_load_cb), NULL);
	gtk_container_add(GTK_CONTAINER(hbox), list_name_entry);
	gtk_widget_show(list_name_entry);

	/*
	button = gtk_button_new_with_label("Remove All");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(list_remove_all_cb), NULL);
	gtk_box_pack_end(GTK_BOX(vbox), button, FALSE, FALSE, 2);
	gtk_widget_show(button);
	*/

	album_menu = album_list_create();
	gtk_box_pack_end(GTK_BOX(vbox), album_menu, FALSE, FALSE, 2);
	gtk_widget_show(album_menu);

	hseparator = gtk_hseparator_new();
	gtk_box_pack_end(GTK_BOX(vbox), hseparator, FALSE, FALSE, 2);
	gtk_widget_show(hseparator);

	return file_list;
}

/*
 * File List selection CALLBACK
 */
void 
file_list_callback(GtkWidget * w, GdkEventButton * event, gpointer user_data)
{
	GtkWidget *event_widget = gtk_get_event_widget((GdkEvent *) event);
	char *filename;
	/*
	if(event->type == GDK_BUTTON_RELEASE && event->button == 3) {
		return;
		gtk_widget_hide(factory->widget);
	}
	*/
	current_list_item = gtk_list_child_position(GTK_LIST(file_list), event_widget);
	//if(event->type != GDK_BUTTON_PRESS) {
	//	gtk_signal_emit_stop_by_name(GTK_OBJECT(w), "button_press_event");
	//	return;
	//}
	if(event->button == 3) {
		gtk_menu_popup(GTK_MENU(factory->widget), NULL, NULL, NULL, NULL, 3, 20);
		//gtk_signal_emit_stop_by_name(GTK_OBJECT(w), "button_press_event");
		return;
	}
	if(event->button == 2) {
		gtk_signal_emit_stop_by_name(GTK_OBJECT(w), "button_press_event");
		delete_file_item(event_widget,
			(int)gtk_list_child_position(GTK_LIST(file_list),
			event_widget));
		return;
	} else if(event->type == GDK_2BUTTON_PRESS){
		current_file = 
			gtk_list_child_position(GTK_LIST(file_list), event_widget);
		filename = g_slist_nth(filenames, current_file)->data;
		play_song(filename);
	}
}

void
delete_file_item(GtkWidget *w, int item)
{
	char *filename = g_slist_nth(filenames, item)->data;
	gtk_container_remove(GTK_CONTAINER(file_list),w);
	/*
	gtk_list_clear_items(GTK_LIST(file_list), item, item + 1);
	*/
	gtk_widget_destroy(w);
	g_free(filename);
	filenames = g_slist_remove(filenames, filename);
	if(current_file >= item) current_file--;
	nfiles--;
	if(nfiles) gtk_gauge_set_value((GtkGauge*)play_list_pos_gauge, (double)(current_file+1.0)/nfiles);
}

void
select_update(void)
{
	gfloat position, page_size, upper, one_height;
	GtkAdjustment *adjustment = gtk_viewport_get_vadjustment(
							GTK_VIEWPORT(file_list->parent));
	gtk_list_select_item(GTK_LIST(file_list), current_file);
	upper = adjustment->upper;
	page_size = adjustment->page_size;
	one_height = upper / nfiles;
	position = one_height * current_file;
	if ((position > adjustment->value) &&
		(position < (adjustment->value + page_size - one_height))) {
		/* this item is visible */
	} else {
		if (position < page_size / 2) {
			adjustment->value = 0.0;
		} else if (position > upper - page_size / 2) {
			adjustment->value = upper - page_size;
		} else {
			adjustment->value = position - page_size / 2;
		}
		gtk_signal_emit_by_name(GTK_OBJECT(adjustment), "value_changed");
	}
	play_song(g_slist_nth(filenames,current_file)->data);
}

void 
list_append(char *filename)
{
	GtkWidget *list_item;
	char *shortname;
	if(fnmatch("*.list", filename, 0) == 0) {
		list_file_load(filename);
		return;
	}

	shortname = g_strdup(basename(filename));
	if(fnmatch("*.gz", shortname, 0) == 0) {
		shortname[strlen(shortname) - 3] = 0;
	}
	list_item = gtk_list_item_new_with_label(shortname);
	gtk_container_add(GTK_CONTAINER(file_list), list_item);
	filenames = g_slist_append(filenames, g_strdup(filename));
	nfiles++;
	if(nfiles) gtk_gauge_set_value((GtkGauge*)play_list_pos_gauge, (double)(current_file+1.0)/nfiles);
	g_free(shortname);
	gtk_widget_show(list_item);
}


void
list_append_begin(void)
{
	gtk_container_disable_resize(GTK_CONTAINER(file_list));
}

void
list_append_end(void)
{
	gtk_container_enable_resize(GTK_CONTAINER(file_list));
}

void
remove_all_cb(void)
{
	GSList *flist;

	//list_append_begin();

	flist = filenames;
	while(flist) {
		g_free(flist->data);
		flist = flist->next;
	}
	g_slist_free(filenames);
	filenames = NULL;
	gtk_list_clear_items(GTK_LIST(file_list), 0, 10000);
	nfiles = 0;
	current_file = -1;
	gtk_gauge_set_value((GtkGauge*)play_list_pos_gauge, 0);

	//list_append_end();
}

void
query_new_list_name(void)
{
	//dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	//vbox = gtk_vbox_new(FALSE, 2);
	//gtk_container_add(GTK_CONTAINER(dialog), vbox);

}

void
list_save_cb(GtkWidget *w)
{
	GList *album_list_name_item;
	char *filename = gtk_entry_get_text((GtkEntry*)list_name_entry);
	if(strcmp(filename, list_file_name) != 0) {
		g_free(list_file_name);
		list_file_name = g_strdup(filename);
	}
	album_list_name_item = album_name_list;
	while(album_list_name_item) {
		if(strcmp(filename, album_list_name_item->data) == 0) break;
		album_list_name_item = album_list_name_item->next;
	}
	if(album_list_name_item == NULL) {
		filename = g_strdup(filename);
		album_name_list = g_list_append(album_name_list, filename);
		album_list_append(filename); 
	}
	list_save();
}

void
list_load_cb(GtkWidget *w)
{
}

void
remove_cb(void)
{
	GtkWidget *child;
	GList *children = GTK_LIST(file_list)->selection;
	if(children) {
		int current_list_item;
		char *filename;
		child = children->data;
		current_list_item = gtk_list_child_position(GTK_LIST(file_list), child);
		filename = g_slist_nth(filenames, current_list_item)->data;
		gtk_list_clear_items(GTK_LIST(file_list), current_list_item, 
			current_list_item + 1);
		filenames = g_slist_remove(filenames, filename);
		g_free(filename);
		if(current_file >= current_list_item) current_file--;
		nfiles--;
		if(nfiles) 
			gtk_gauge_set_value((GtkGauge*)play_list_pos_gauge, 
				(double)(current_file+1.0)/nfiles);
	}
}

void
list_play_cb(void)
{
	GtkWidget *child;
	GList *children = GTK_LIST(file_list)->selection;
	if(children) {
		child = children->data;
		current_file = gtk_list_child_position(GTK_LIST(file_list), child);
		play_song(g_slist_nth(filenames, current_file)->data);
	}
}

void
popup_delete_cb(GtkWidget *w, gpointer data)
{
	char *filename = g_slist_nth(filenames, current_list_item)->data;
	gtk_list_clear_items(GTK_LIST(file_list), current_list_item, 
		current_list_item + 1);
	filenames = g_slist_remove(filenames, filename);
	g_free(filename);
	if(current_file >= current_list_item) current_file--;
	nfiles--;
	if(nfiles) 
		gtk_gauge_set_value((GtkGauge*)play_list_pos_gauge, 
			(double)(current_file+1.0)/nfiles);
}

void
popup_play_cb(GtkWidget *w, gpointer data)
{
	current_file = current_list_item;
	play_song(g_slist_nth(filenames, current_file)->data);
}

void
default_list_load(void)
{
	list_file_load("autosave.list");
}

void
list_file_load(char *list_name)
{
	FILE *fp;
	char *s;
	char list_full_name[256];
	remove_all_cb();

	if(list_file_name) g_free(list_file_name);
	list_file_name = g_strdup(list_name);
	//g_print("%s in %s\n", list_file_name, __FUNCTION__);
	gtk_entry_set_text((GtkEntry*)list_name_entry, list_file_name);

	sprintf(list_full_name,"%s/.sori/%s", getenv("HOME"), list_name);
	fp = fopen(list_full_name, "r");
	if(fp == NULL) return;

	//list_append_begin();
	while((s = read_line(fp)) != NULL) {
		if(*s == 0) continue;
		list_append(s);
	}
	//list_append_end();
	fclose(fp);
}

void
default_list_save(void)
{
	if(list_file_name && (strcmp(list_file_name, "autosave.list") == 0)) {
		list_save();
	}
}

void
list_save(void)
{
	FILE *fp;
	GSList *flist;
	char list_full_name[256];

	sprintf(list_full_name, "%s/.sori/%s", getenv("HOME"), list_file_name);

	fp = fopen(list_full_name, "w");
	if(fp == NULL) {
		g_print("Can't save play list\n");
		return;
	}
	flist = filenames;
	while(flist) {
		fprintf(fp, "%s\n", (char*)flist->data);
		flist = flist->next;
	}
	fclose(fp);
}


#include <glob.h>

GtkWidget *
album_list_create(void)
{
	GtkWidget *album_menu;
	char *album_name;
	char sori_dir[256];
	glob_t globd;
	int i;

	album_menu = gtk_option_menu_new();
	//gtk_box_pack_start(GTK_BOX(hbox), option_menu, TRUE, TRUE, 0);
	//gtk_widget_show(option_menu);

	album_list = gtk_menu_new();
	sprintf(sori_dir, "%s/.sori/*.list", getenv("HOME"));
	glob(sori_dir, 0, NULL, &globd);
	album_name = "autosave.list";
	album_name_list = g_list_append(album_name_list, album_name);
	album_list_append(album_name);
	for(i=0;i<globd.gl_pathc;i++) {
		if(strcmp(basename(globd.gl_pathv[i]), "autosave.list") == 0) continue;
		album_name = g_strdup(basename(globd.gl_pathv[i]));
		album_name_list = g_list_append(album_name_list, album_name);
		album_list_append(album_name);
	}
	globfree(&globd);

	gtk_option_menu_set_menu(GTK_OPTION_MENU(album_menu), album_list);
	return album_menu;
}

void
album_select(GtkWidget *w)
{
	char *label;
	if (!(((GtkCheckMenuItem *) w)->active)) return;
	//g_print("w: %p\n", w);

	//labelw = GTK_LABEL(GTK_BIN(w)->child);
	//g_print("widget: %p\n", labelw);
	label = gtk_object_get_user_data((GtkObject*)w);
	//labelw->label;
	//g_print("string: %s\n", label);

	list_file_load(label);
}

void
album_list_append(char *file_name)
{
	GtkWidget *menu_item;
	static GSList *group = NULL;
	menu_item = gtk_radio_menu_item_new_with_label(group, file_name);
	//g_print("w: %p\n", menu_item);
	//g_print("labelw: %p\n",GTK_LABEL(GTK_BIN(menu_item)->child));
	gtk_signal_connect(GTK_OBJECT(menu_item), "activate",
					   GTK_SIGNAL_FUNC(album_select), NULL);
	group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(menu_item));
	gtk_menu_append(GTK_MENU(album_list), menu_item);
	gtk_object_set_user_data(GTK_OBJECT(menu_item), file_name);
	gtk_widget_show(menu_item);
	//g_print("labelw: %p\n",GTK_LABEL(GTK_BIN(menu_item)->child));
}
