
/* this file is a part of sori software, (C) Hwang chi-duck 1997               */

#include <string.h>

#include <gtk/gtk.h>
#include "dialog.h"

char selecteddir[500];
GtkWidget *fs_selection_dialog;
extern GtkWidget *add_button;

static GString *fullname = NULL;

void option_append(char *dir_name, GtkWidget * dir_menu);
void file_selection_callback(GtkWidget * w, gpointer user_data);
void gotodir(GtkWidget * w, GtkOptionMenu * option);
void diroption(GtkWidget *);

void
getfilename(GtkWidget * w, gpointer user_data)
{
	char *filename = gtk_object_get_user_data(GTK_OBJECT(w));
	g_string_sprintf(fullname, "%s%s", selecteddir, filename);
	list_append(fullname->str);
}

void
create_file_selection_box(GtkWidget * box)
{
	GList *children;
	GtkWidget *button;
	GtkFileSelection *filesel;
	GtkWidget *frame = gtk_frame_new(NULL);
	//GtkWidget *label = gtk_label_new("  ");

	fs_selection_dialog = gtk_file_selection_new(NULL);
	filesel = (GtkFileSelection *) fs_selection_dialog;
	//gtk_widget_set_usize(GTK_FILE_SELECTION(fs_selection_dialog)->file_list->parent->parent,0, 120);
	//gtk_widget_set_usize(GTK_FILE_SELECTION(fs_selection_dialog)->dir_list->parent->parent,0,     120);

	// OK button => add button translation
	add_button = GTK_FILE_SELECTION(fs_selection_dialog)->ok_button;
	gtk_signal_disconnect_by_data(GTK_OBJECT(GTK_FILE_SELECTION(fs_selection_dialog)->selection_entry), add_button);
	//gtk_widget_destroy(button);
	children = gtk_container_children(GTK_CONTAINER(add_button));
	gtk_label_set(GTK_LABEL(children->data), "Add");
	gtk_container_remove(GTK_CONTAINER(add_button->parent), add_button);
	GTK_WIDGET_UNSET_FLAGS(add_button, GTK_CAN_DEFAULT);
	/*
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   GTK_SIGNAL_FUNC(file_selection_callback), (gpointer) FILELOAD_OK);

   */
	// help button => close button translation
	button = GTK_FILE_SELECTION(fs_selection_dialog)->help_button;
	gtk_widget_destroy(button);
	/*
	GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_DEFAULT);
	children = gtk_container_children(GTK_CONTAINER(button));
	gtk_label_set(GTK_LABEL(children->data), "Close");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   GTK_SIGNAL_FUNC(close_dialog), NULL);
					   */

	// cancel button => add-all button translation
	button = GTK_FILE_SELECTION(fs_selection_dialog)->cancel_button;
	{ GtkWidget *parent = button->parent;
	  gtk_widget_destroy(button);
	  gtk_widget_destroy(parent);
	}
	/*
	GTK_WIDGET_UNSET_FLAGS(button, GTK_CAN_DEFAULT);
	children = gtk_container_children(GTK_CONTAINER(button));
	gtk_label_set(GTK_LABEL(children->data), "Add All");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   (GtkSignalFunc) file_selection_callback, (gpointer) FILELOAD_ALL);
					   */

	diroption(fs_selection_dialog);

	gtk_widget_show(frame);
	gtk_widget_reparent(GTK_FILE_SELECTION(fs_selection_dialog)->main_vbox, frame);
	//gtk_widget_hide(fs_selection_dialog);
	fullname = g_string_new("");
	gtk_container_add(GTK_CONTAINER(box), frame);
}

void
add_cb(void)
{
	list_append(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs_selection_dialog)));
}

void
add_all_cb(void)
{
	char *c;
	strcpy(selecteddir, gtk_file_selection_get_filename(
							   GTK_FILE_SELECTION(fs_selection_dialog)));
	if ((c = strrchr(selecteddir, '/')))
		*(c + 1) = 0;
	gtk_container_foreach(GTK_CONTAINER(
		 GTK_FILE_SELECTION(fs_selection_dialog)->file_list),
		  getfilename, NULL);
}

/* 
 * File selection box callback 
 */
void
file_selection_callback(GtkWidget * w, gpointer user_data)
{
	switch ((int) user_data) {
	case FILELOAD_OK:
		list_append(gtk_file_selection_get_filename(
							   GTK_FILE_SELECTION(fs_selection_dialog)));
		break;
	case FILELOAD_ALL:
		{
			char *c;
			list_append_begin();
			strcpy(selecteddir,
				   gtk_file_selection_get_filename(
							   GTK_FILE_SELECTION(fs_selection_dialog)));
			if ((c = strrchr(selecteddir, '/')))
				*(c + 1) = 0;
			gtk_container_foreach(GTK_CONTAINER(
					 GTK_FILE_SELECTION(fs_selection_dialog)->file_list),
								  getfilename, NULL);
			list_append_end();
		}
		break;
	default:
		break;
	}
}

void
go_hot_dir(GtkWidget * w)
{
	if (((GtkCheckMenuItem *) w)->active) {
		char *dir_name = gtk_object_get_user_data((GtkObject *) w);
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fs_selection_dialog),
										dir_name);
	}
}

// hot directories list
void
diroption(GtkWidget * fs_selection_dialog)
{
	GtkWidget *dirframe;
	GtkWidget *hbox, *option_menu, *dirs, *label;
	GSList *hot_dir = NULL;
	char *s;
	int len;
	FILE *fp;
	char hotdir[256];
	extern char *read_line(FILE *fp);

	sprintf(hotdir, "%s/.sori/hotdir", getenv("HOME"));
	fp = fopen(hotdir, "r");
	if(fp == NULL) {
		printf("can't open %s\n", hotdir);
		return;
	}
	while((s = read_line(fp)) != NULL) {
		len = strlen(s);
		if(s[len - 1] != '/') {
			s[len] = '/';
			s[len+1] = 0;
		}
		hot_dir = g_slist_append(hot_dir, g_strdup(s));
	}
	fclose(fp);

	dirframe = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(dirframe), GTK_SHADOW_ETCHED_IN);

	hbox = gtk_hbox_new(FALSE, 5);
	gtk_container_border_width(GTK_CONTAINER(hbox), 5);
	gtk_container_add(GTK_CONTAINER(dirframe), hbox);
	gtk_widget_show(hbox);

	label = gtk_label_new("Hot Directory:");
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
	gtk_widget_show(label);


	option_menu = gtk_option_menu_new();
	gtk_box_pack_start(GTK_BOX(hbox), option_menu, TRUE, TRUE, 0);
	gtk_widget_show(option_menu);

	dirs = gtk_menu_new();
	g_slist_foreach(hot_dir, (GFunc) option_append, (gpointer) dirs);
	g_slist_free(hot_dir);

	gtk_option_menu_set_menu(GTK_OPTION_MENU(option_menu), dirs);
	gtk_box_pack_end(GTK_BOX(GTK_FILE_SELECTION(fs_selection_dialog)->main_vbox),
					  dirframe, FALSE, FALSE, 0);
	gtk_widget_show(dirframe);
}

void
option_append(char *dir_name, GtkWidget * dir_menu)
{
	GtkWidget *menu_item;
	static GSList *group = NULL;
	menu_item = gtk_radio_menu_item_new_with_label(group, dir_name);
	gtk_signal_connect(GTK_OBJECT(menu_item), "activate",
					   GTK_SIGNAL_FUNC(go_hot_dir), NULL);
	group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(menu_item));
	gtk_menu_append(GTK_MENU(dir_menu), menu_item);
	gtk_object_set_user_data(GTK_OBJECT(menu_item), dir_name);
	gtk_widget_show(menu_item);
}
