
/* this file is a part of sori software, (C) Hwang chi-duck 1997              */

#include <gtk/gtk.h>

#include "dialog.h"


GtkWidget *file_list;
GtkWidget *file_selection_box;
GtkWidget *add_button;
void remove_all_cb(void);
void add_all_cb(void);
void add_cb(void);
void getfilename(GtkWidget * w, gpointer user_data);
void list_play_cb(void);
void remove_cb(void);


GtkWidget *
fs_dialog_create(void)
{
	GtkWidget *fs_dialog;
	GtkWidget *hbox;
	GtkWidget *vseparator;
	GtkWidget *list_frame;
	GtkWidget *vbox, *button;

	fs_dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect(GTK_OBJECT(fs_dialog), "destroy",
		GTK_SIGNAL_FUNC(window_destroyed), &fs_dialog);
	gtk_container_border_width((GtkContainer*)fs_dialog, 5);
	gtk_window_position(GTK_WINDOW(fs_dialog), GTK_WIN_POS_MOUSE);
	hbox = gtk_hbox_new(FALSE, 3);
	gtk_container_add(GTK_CONTAINER(fs_dialog), hbox);
	gtk_widget_show(hbox);

	list_frame = gtk_frame_new("File Selection");
	//gtk_container_border_width((GtkContainer*)list_frame, 5);
	gtk_frame_set_shadow_type(GTK_FRAME(list_frame), GTK_SHADOW_ETCHED_IN);
	gtk_box_pack_start(GTK_BOX(hbox), list_frame, TRUE, TRUE, 0);
	gtk_widget_show(list_frame);

	create_file_selection_box(list_frame);

	vseparator = gtk_vseparator_new();
	gtk_container_add(GTK_CONTAINER(hbox), vseparator);
	gtk_widget_show(vseparator);

	vbox = gtk_vbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 0);
	gtk_widget_show(vbox);

	vseparator = gtk_vseparator_new();
	gtk_container_add(GTK_CONTAINER(hbox), vseparator);
	gtk_widget_show(vseparator);

	button = gtk_label_new(" ");
	gtk_box_pack_start(GTK_BOX(vbox), button, TRUE, TRUE, 0);
	gtk_widget_show(button);

	//button = gtk_button_new_with_label("Add");
	gtk_signal_connect(GTK_OBJECT(add_button), "clicked", 
					   GTK_SIGNAL_FUNC(add_cb), NULL);
	//gtk_widget_set_uposition(button, -2, 100);
	gtk_box_pack_start(GTK_BOX(vbox), add_button, FALSE, TRUE, 5);
	gtk_widget_show(add_button);

	button = gtk_button_new_with_label("Add All");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   GTK_SIGNAL_FUNC(add_all_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 5);
	gtk_widget_show(button);

	button = gtk_button_new_with_label("Play");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   GTK_SIGNAL_FUNC(list_play_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 5);
	gtk_widget_show(button);

	button = gtk_button_new_with_label("Remove");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   GTK_SIGNAL_FUNC(remove_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 5);
	gtk_widget_show(button);

	button = gtk_button_new_with_label("Remove All");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(remove_all_cb), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 5);
	gtk_widget_show(button);

	button = gtk_button_new_with_label("Close");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
					   GTK_SIGNAL_FUNC(close_dialog), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 5);
	gtk_widget_show(button);

	button = gtk_label_new(" ");
	gtk_box_pack_end(GTK_BOX(vbox), button, TRUE, TRUE, 0);
	gtk_widget_show(button);


	list_frame = gtk_frame_new("List");
	//gtk_container_border_width((GtkContainer*)list_frame, 5);
	gtk_frame_set_shadow_type(GTK_FRAME(list_frame), GTK_SHADOW_ETCHED_IN);
	gtk_container_add(GTK_CONTAINER(hbox), list_frame);
	gtk_widget_show(list_frame);

	file_list = create_file_list(list_frame);
	default_list_load();
	return fs_dialog;
}
