
#ifndef __GTK_GAUGE_H__
#define __GTK_GAUGE_H__

#include <gtk/gtkwidget.h>
#include <gtk/gtkadjustment.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_GAUGE(obj)          GTK_CHECK_CAST (obj, gtk_gauge_get_type (), GtkGauge)
#define GTK_GAUGE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_gauge_get_type (), GtkGaugeClass)
#define GTK_IS_GAUGE(obj)       GTK_CHECK_TYPE (obj, gtk_gauge_get_type ())
typedef struct _GtkGauge GtkGauge;
typedef struct _GtkGaugeClass GtkGaugeClass;

struct _GtkGauge {
	GtkWidget widget;
	GdkGC *gc;
	int width, height;
	int position;
};

struct _GtkGaugeClass {
	GtkWidgetClass parent_class;
	void (*pressed)(GtkGauge *gauge, gint *position);
	void (*right_pressed)(GtkGauge *gauge);
};

GtkWidget *gtk_gauge_new(int width, int height, GtkAdjustment *adj);
void gtk_gauge_set_value(GtkGauge *gauge, float val);

#endif /* __GTK_GAUGE_H__ */
