
/* this file is a part of sori software, (C) Hwang chi-duck 1997              */

#include <gtk/gtk.h>
#include "sori.h"
#include "dialog.h"

GtkWidget *
option_dialog_create()
{
	GtkWidget *option_dialog;
	GtkWidget *vbox, *frame;
	GtkWidget *button;
	GtkWidget *box_in_frame;
	GtkWidget *volume_bar;
	GtkWidget *hseparator;
	
	option_dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	//gtk_widget_set_usize(option_dialog, 150, -1);
	gtk_container_border_width(GTK_CONTAINER(option_dialog), 5);
	gtk_window_position(GTK_WINDOW(option_dialog), GTK_WIN_POS_MOUSE);
	vbox = gtk_vbox_new(FALSE, 2);
	gtk_container_add(GTK_CONTAINER(option_dialog), vbox);
	gtk_widget_show(vbox);

	frame = gtk_frame_new("Play Option");
	//gtk_container_border_width(GTK_CONTAINER(frame), 5);
	gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 2);
	gtk_widget_show(frame);

	box_in_frame = gtk_hbox_new(TRUE, 2);
	gtk_container_border_width(GTK_CONTAINER(box_in_frame), 15);
	gtk_container_add(GTK_CONTAINER(frame), box_in_frame);
	gtk_widget_show(box_in_frame);

	button = gtk_toggle_button_new_with_label("shuffle play");
	gtk_toggle_button_set_mode(GTK_TOGGLE_BUTTON(button), TRUE);
	gtk_toggle_button_set_state ((GtkToggleButton *)button, shuffle);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(toggle_parameter), &shuffle);
	gtk_box_pack_start(GTK_BOX(box_in_frame), button, FALSE, FALSE, 2);
	gtk_widget_show(button);

	button = gtk_toggle_button_new_with_label("repeat play");
	gtk_toggle_button_set_mode(GTK_TOGGLE_BUTTON(button), TRUE);
	gtk_toggle_button_set_state ((GtkToggleButton *)button, auto_next);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(toggle_parameter), &auto_next);
	gtk_box_pack_start(GTK_BOX(box_in_frame), button, FALSE, FALSE, 2);
	gtk_widget_show(button);

	hseparator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox), hseparator, FALSE, FALSE, 2);
	gtk_widget_show(hseparator);

	frame = gtk_frame_new("Volume");
	//gtk_container_border_width(GTK_CONTAINER(frame), 5);
	gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 2);
	gtk_widget_show(frame);

	volume_bar = volume_bar_new(-1); // master volume, mono
	gtk_container_add(GTK_CONTAINER(frame), volume_bar);
	gtk_widget_show(volume_bar);

	hseparator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox), hseparator, FALSE, FALSE, 2);
	gtk_widget_show(hseparator);

	button = gtk_button_new_with_label("Close");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(close_dialog), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
	gtk_widget_show(button);

	return option_dialog;
}



