#ifndef __SORI_H__
#define __SORI_H__

#include "config.h"

extern GtkWidget *song_name_label;
extern GtkWidget *song_pos_gauge;
extern GtkWidget *play_list_pos_gauge;
extern int song_type;
extern int not_play;
extern int current_file;
extern int nfiles;
extern int shuffle, auto_next;
extern int paused;
extern GSList  *filenames;


void minimize_cb(GtkWidget *w);
void close_cb(GtkWidget *w);
void next_song_cb(GtkWidget *w);
void previous_song_cb(GtkWidget *w);
void fast_forward_cb(GtkWidget *w);
void rewind_cb(GtkWidget *w);
void help_cb(GtkWidget *w);
void about_cb(GtkWidget *w);
void options_cb(GtkWidget *w);
void disk_operations_cb(GtkWidget *w);
void song_information_cb(GtkWidget *w);
void pause_cb(GtkWidget *w);
void stop_cb(GtkWidget *w);
void play_cb(GtkWidget *w);
void song_position_change_cb(GtkWidget *w, int position);
void play_list_position_cb(GtkWidget *w, int position);

SoriConfig * parse_file(char *filename);
GtkWidget * sori_new(char *filename);
void play_song(char *filename);
void play_next(void);
void play_previous(void);
void play_end(void);
int fork_player(void);
void kill_player(void);
void player_is_dead(void);
void show_position(float percent);
void change_position(float percent);
int file_type(char *filename);
void set_current_song_name(char *song);

#endif /* __SORI_H__ */
