/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __GTK_SORI_LABEL_H__
#define __GTK_SORI_LABEL_H__


#include <gtk/gtkwidget.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GTK_SORI_LABEL(obj)          GTK_CHECK_CAST (obj, gtk_sori_label_get_type (), GtkSoriLabel)
#define GTK_SORI_LABEL_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_sori_label_get_type (), GtkSoriLabelClass)
#define GTK_IS_SORI_LABEL(obj)       GTK_CHECK_TYPE (obj, gtk_sori_label_get_type ())


typedef struct _GtkSoriLabel       GtkSoriLabel;
typedef struct _GtkSoriLabelClass  GtkSoriLabelClass;

struct _GtkSoriLabel
{
	GtkWidget widget;
	GdkGC *gc;
	GdkFont *font;
	  char *label;
	  int width, height;
};

struct _GtkSoriLabelClass
{
	GtkWidgetClass parent_class;
};


guint      gtk_sori_label_get_type (void);
GtkWidget* gtk_sori_label_new      (GdkGC *gc, GdkFont *font, char *str, int width, int height);
void       gtk_sori_label_set      (GtkSoriLabel  *label,
			       char      *str);
void       gtk_sori_label_get      (GtkSoriLabel  *label,
			       char     **str);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_SORI_LABEL_H__ */
