
#ifndef __GTK_SPACE_H__
#define __GTK_SPACE_H__


#include <gtk/gtkcontainer.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_SPACE(obj)          GTK_CHECK_CAST (obj, gtk_space_get_type (), GtkSpace)
#define GTK_SPACE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_space_get_type (), GtkSpaceClass)
#define GTK_IS_SPACE(obj)       GTK_CHECK_TYPE (obj, gtk_space_get_type ())

typedef struct _GtkSpace GtkSpace;
typedef struct _GtkSpaceClass GtkSpaceClass;
typedef struct _GtkSpaceChild GtkSpaceChild;

struct _GtkSpace
{
	GtkContainer parent;
	GList *children;
};

struct _GtkSpaceClass
{
	GtkContainerClass parent_class;
};

struct _GtkSpaceChild
{
	GtkWidget *widget;
	int x, y;
};


guint32 gtk_space_get_type();
GtkWidget *gtk_space_new(int width, int height);
void gtk_space_put(GtkSpace *space, GtkWidget *w, int x, int y); 


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif    /* __GTK_SPACE_H__ */
