/* 
 * MESSAGE FROM TIMIDITY TO MOTIF
 */
#define REFRESH_MESSAGE 1
#define HELPMODE_MESSAGE 2
#define TOTALTIME_MESSAGE 3
#define MASTERVOL_MESSAGE 4
#define FILENAME_MESSAGE 5
#define CURTIME_MESSAGE 6
#define NOTE_MESSAGE 7
#define PROGRAM_MESSAGE 8
#define VOLUME_MESSAGE 9
#define EXPRESSION_MESSAGE 10
#define PANNING_MESSAGE 11
#define SUSTAIN_MESSAGE 12
#define PITCH_MESSAGE 13
#define RESET_MESSAGE 14
#define CLOSE_MESSAGE 15
#define CMSG_MESSAGE 16
#define FILE_LIST_MESSAGE 17
#define NEXT_FILE_MESSAGE 18
#define PREV_FILE_MESSAGE 19
#define TUNE_END_MESSAGE 20

/* 
 * MESSAGE ON THE PIPE FROM MAIN TOWARD TIMIDITY
 */
#define MOTIF_CHANGE_VOLUME 1
#define MOTIF_CHANGE_LOCATOR 2
#define MOTIF_QUIT 3
#define MOTIF_PLAY_FILE 4
#define MOTIF_NEXT 5
#define MOTIF_PREV 6
#define MOTIF_RESTART 7
#define MOTIF_FWD 8
#define MOTIF_RWD 9
#define MOTIF_PAUSE 10


/*
 * CONSTANTS FOR MOTIF MENUS
 */
#define MENU_OPEN 1
#define MENU_QUIT 2
#define MENU_TOGGLE 3

#define DIALOG_CANCEL 1
#define DIALOG_OK 2
#define DIALOG_ALL 3
#define DIALOG_ADD 4


/*
 * Pipe function interfaces
 */
void timidity_int_write(int c);
void timidity_int_read(int *c);

void timidity_string_write(char *str);
void timidity_string_read(char *str);

void timidity_open();
int timidity_read_ready();

void timidity_handle_input ();
void timidity_scale_callback (GtkWidget * widget, gpointer user_data);
void timidity_button_callback(GtkWidget * widget, gpointer user_data);
void timidity_forward(void);
void timidity_backward(void);
void timidity_play_song(char *filename);
void timidity_change_position(float position);
void timidity_change_volume(float position);
void timidity_quit(void);
void timidity_pause(void);
