
/* this file is a part of sori software, (C) Hwang chi-duck 1997              */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <sys/soundcard.h>
#include <errno.h>
#include <string.h>

#include <gtk/gtk.h>

#define MAX_DEV 10

int mixer = -1; /* file descripter of mixer device */


void volume_change_callback(GtkAdjustment *adj, gpointer data);

static int
mixer_init(void)
{
    mixer = open("/dev/mixer", O_RDWR); 
	return mixer;
}

GtkWidget *
volume_bar_new(int dev)
{
	int n;
	GtkObject *adj;
	GtkWidget *scale;

	if(mixer < 0) {
		mixer_init();
	}
	if(mixer < 0) return NULL;
	if(dev < 0)  dev = 0; // master

	ioctl(mixer, MIXER_READ(dev), &n);
	adj = gtk_adjustment_new ((n >> 8)&0x7f, 0, 110, 1, 10, 10);
	gtk_signal_connect(adj, "value_changed",
		GTK_SIGNAL_FUNC(volume_change_callback), (gpointer)(dev));
	scale = gtk_hscale_new (GTK_ADJUSTMENT (adj));
	gtk_scale_set_draw_value(GTK_SCALE(scale), FALSE);
	return scale;
}

void
volume_change_callback(GtkAdjustment *adj, gpointer data)
{
	int dev = (int)data;
	int n;
	n = adj->value;
	n &= 0x7f;
	n = n  + (n << 8);
	ioctl(mixer, MIXER_WRITE(dev), &n);
}

